;;; Defining printc and printi for Linux 
	
;;; To assemble, link and run under Linux ELF (ssh.itu.dk)
;;;   nasm -f elf tryfun.asm -o try.o
;;;   gcc try.o -o try
;;;   ./try

global main			; Define entry point for this code
extern printf			; Refer to C library function

SECTION code
	
;;; Print uppercase ASCII characters and their codes 90Z ... 65A
		
main:
	push	ebp
	mov	ebp, esp

	mov	eax, dword 90
.loop:	push    eax		; Push printc argument
	call	printc		; Call printc
	call	printi		; Call printi on same argument
	add	esp, byte 4	; Pop printc argument
	dec	eax
	cmp	eax, 64
	jnz	.loop
	push	dword 10	; Push and print newline
	call	printc
	add	esp, byte 4

	mov	esp, ebp
	pop	ebp
	ret

;;; The printi and printc routines are called like this:
;;;	push	<argument>
;;;	call	printi
;;;	add	esp, byte 4
;;; They preserve the contents of all registers, for use in debugging.
	
printi:				; Print decimal integer
	push	ebp		; Save ebp on stack
	mov	ebp, esp	; Save stack pointer in ebp
	pushad			; Save all registers
	push	dword [ebp+8]	; Push (integer) argument, 2nd printf arg
	push	dword printistr ; Push format string, 1st printf arg
	call	printf		; Print using C library printf
	add	esp, byte 8	; Pop printf's arguments
	popad			; Restore all registers
	mov	esp, ebp	; Restore stack pointer
	pop	ebp		; Restore ebp
	ret			; Return

printc:				; Print ASCII character
	push	ebp		; Save ebp on stack
	mov	ebp, esp	; Save stack pointer in ebp
	pushad			; Save all registers
	push	dword [ebp+8]	; Push (char) argument, 2nd printf arg
	push	dword printcstr	; Push format string, 1st printf arg
	call	printf		; Print using C library printf
	add	esp, byte 8	; Pop printf's arguments
	popad			; Restore all registers
	mov	esp, ebp	; Restore stack pointer
	pop	ebp		; Restore ebp
	ret			; Return 
		
segment DATA
	printistr	db	'%d ', 0
	printcstr	db	'%c', 0
	
